%global gem_name puppetserver-ca

Name: rubygem-%{gem_name}
Version: 1.7.0
Release: 1%{?dist}
Summary: A simple CLI tool for interacting with Puppet Server's Certificate Authority
License: ASL 2.0
URL: https://github.com/puppetlabs/puppetserver-ca-cli
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
# to get the tests
# git clone https://github.com/puppetlabs/puppetserver-ca-cli
# cd puppetserver-ca-cli && git archive -v -o puppetserver-ca-1.7.0-tests.txz 1.7.0 spec/
Source1: %{gem_name}-%{version}-tests.txz
BuildRequires: ruby(release)
BuildRequires: rubygems-devel
# For the tests
BuildRequires: rubygem(rspec)
BuildRequires: rubygem(hocon)
BuildRequires: ruby-facter
BuildRequires: git
Requires: ruby-facter
# being specific, because it requires ruby-facter, not rubygem-facter
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^rubygem\\(facter\\)$

BuildArch: noarch

%description
A simple CLI tool for interacting with Puppet Server's Certificate Authority.

%package doc
Summary: Documentation for %{name}
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version} -b1
%gemspec_remove_dep -g facter -s ../%{gem_name}-%{version}.gemspec

%build
gem build ../%{gem_name}-%{version}.gemspec
	

%install
%gem_install

mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

mkdir -p %{buildroot}%{_bindir}
cp -a .%{_bindir}/* \
        %{buildroot}%{_bindir}/

# fixing permissions and removing unnecessary files
find %{buildroot}%{gem_instdir}/exe -type f | xargs chmod a+x
rm -rf %{buildroot}%{gem_instdir}/{.gitignore,.travis.yml}

%check
pushd .%{gem_instdir}
ln -s %{_builddir}/spec .
# fixing gemspec and Gemfile to run the tests
sed -i -r 's/^require\ \"bundler\/setup.*//g' spec/spec_helper.rb
sed -i -r 's/^Bundler\.require.*//g' spec/spec_helper.rb
sed -i -r 's/.*\.add(_runtime)?_dependency.*facter.*//g' %{_builddir}/%{gem_name}-%{version}/%{gem_instdir}/%{gem_name}.gemspec
sed -i -r 's/^gem\s.*pry.*//g' %{_builddir}/%{gem_name}-%{version}/%{gem_instdir}/Gemfile
sed -i -r 's/.*\.add(_development)?_dependency.*rake.*//g' %{_builddir}/%{gem_name}-%{version}/%{gem_instdir}/%{gem_name}.gemspec
# removing server_list tests, they look flaky -- checking with the upstream
sed -i "/it 'correctly\ reads\ server_list/,/end/ s/^/#/" spec/puppetserver/ca/config/puppet_spec.rb
rspec spec
popd

%files
%dir %{gem_instdir}
%{_bindir}/puppetserver-ca
%{gem_libdir}
%{gem_spec}
%license %{gem_instdir}/LICENSE
%exclude %{gem_cache}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CONTRIBUTING.md
%doc %{gem_instdir}/CODE_OF_CONDUCT.md
%doc %{gem_instdir}/CODEOWNERS
%doc %{gem_instdir}/README.md
%doc %{gem_instdir}/bin
%doc %{gem_instdir}/exe
%{gem_instdir}/Gemfile
%{gem_instdir}/Rakefile
%{gem_instdir}/%{gem_name}.gemspec
%exclude %{gem_instdir}/.rspec

%changelog
* Wed Dec 18 2019 Breno Brand Fernandes <brandfbb@gmail.com> - 1.7.0-1
- First build
